
User Interface - Bug #3071

Bug # 2677 (New): fix drawing and functional differences between P2J GUI and 4GL GUI

A NPE is thrown when Alt-Tab while COMBO-BOX drop down active

04/19/2016 11:45 AM - Hynek Cihlar

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Hynek Cihlar % Done: 100%

Category:  Estimated time: 0.00 hour

Target version: Cleanup and Stabilization for GUI   

billable: No case_num:  

vendor_id: GCD   

Description

History

#1 - 04/19/2016 11:50 AM - Hynek Cihlar

This can be reproduced in current trunk.

The steps:

1. Open COMBO-BOX drop down by clicking into the widget.

2. Press Alt-tab.

3. An NPE is thrown, see below for the call stack.

Thread [main] (Suspended (exception NullPointerException))    

    ThinClient.invokeTriggers(Widget, Widget, long, int, boolean, Integer, Integer) line: 16770    

    ThinClient.invokeTriggers(Widget, Widget, int, boolean) line: 16639    

    ThinClient.processProgressEvent(Event) line: 16217    

    FocusManager.focusChange(Widget, boolean, boolean) line: 1388    

    ThinClient.nextTabStop(Widget) line: 18350    

    ComboBoxGuiImpl(ComboBox<O>).processKeyEvent(KeyInput) line: 505    

    ComboBoxGuiImpl.processKeyEvent(KeyInput) line: 494    

    ComboBox$1.run() line: 1369    

    ThinClient.eventBracket(boolean, Runnable) line: 14272    

    ThinClient.eventDrawingBracket(Widget<?>, boolean, boolean, Runnable) line: 14213    

    ThinClient.independentEventDrawingBracket(Widget, Runnable) line: 14086    

    ComboBoxGuiImpl(ComboBox<O>).processSystemKey(KeyInput) line: 1364    

    ComboBoxGuiImpl.processFocusMoveKey(KeyInput) line: 660    

    ComboBoxGuiImpl.postprocessDropDown() line: 940    

    ComboBoxGuiImpl(ComboBox<O>).activate() line: 1153    

 

The cause seems to be in FocusManager. It must be made aware of the overlay windows when calculating the next focused widget on TAB.
#2 - 04/25/2016 05:02 PM - Greg Shah

- Start date deleted (04/19/2016)

- Parent task set to #2677

#3 - 05/19/2016 06:14 PM - Hynek Cihlar

Cannot reproduce anymore, resolved by #3062.

#4 - 05/19/2016 06:15 PM - Hynek Cihlar

- % Done changed from 0 to 100

#5 - 05/19/2016 06:16 PM - Greg Shah

- Target version set to Milestone 16

- Status changed from New to Closed

- Assignee set to Hynek Cihlar

#6 - 11/16/2016 12:22 PM - Greg Shah

- Target version changed from Milestone 16 to Cleanup and Stabilization for GUI
